/*
   Run and visualize this program using this web site,

   http://pythontutor.com/c.html#mode=edit
*/
#include <stdio.h>
#include <stdlib.h>

int nums1[] = {5, 4, 3, 2, 1};  // a global variable

//int f(int  n1[], int s1, int  n2[], int s2){
//int f(int *n1,   int s1, int *n2,   int s2) {
int f(int n1[5], int s1, int n2[5], int s2)  // the 5's are ignored
{
  if (s1 != s2)
     return 0;

  int result = 1;
  for (int i = 0; i < s1; i++)
  {
    if (n1[i] != n2[i])
    {
       result = 0;
       n2[i] = n1[i];  // a side effect
       break;
    }
  }
  return result;
}


int main()
{
  int nums2[]  = {1, 2, 3, 4, 5};  // local variable
  int nums3[5] = {6, 7, 8, 9};     // local variable
  int r1 = f(nums2, 5, nums3, 4);  // the arguments are a mixture of literals and variables
  int r2 = f((int *[]){5,4,3,2,1}, 5, nums1, 5);  // a literal array argument
  int *nums4 = (int*)malloc(10 * sizeof(int));  // dynamic allocation of an array
  for (int i = 0; i < 10; ++i)   // initialize the dynamically allocated array
  {
     nums4[i] = i+1;
  }
  int r3 = f(nums1, 5, nums4, 5);  // f can have side effects
      r3 = f(nums1, 5, nums4, 5);
      r3 = f(nums1, 5, nums4, 5);
      r3 = f(nums1, 5, nums4, 5);
      r3 = f(nums1, 5, nums4, 5);
  printf("%d, %d, %d\n", r1, r2, r3);
  free(nums4);
  return 0;
}
